#ifndef BASE_H
#define BASE_H

#include <vector>
using namespace std;

#include "resources.h"

#define B_OPS		0 // Root node, always present 
#define B_SOLARGEN	1
#define B_FISSION	2
#define B_FUSION	3
#define B_HAB		4
#define B_HYDRO		5
#define B_RECYCLER	6
#define B_LAB		7
#define B_FAB		8
#define B_CHEM		9
#define B_REFINERY	10
#define B_MINER		11
#define B_AIRPROC	12
#define B_STORAGE	13

#define B_PAD		14  // Landing pad
#define B_XNODE		15  // Node with 4 connectors in + pattern

#define BUILDINGS	16

extern char *bname[BUILDINGS];

class Base;

class Building
{
public:

	int type;
	char buffer[50];  // getstring buffer
	Base *base;

	Building *parent;
	Building *edges[4];


	Building(Base *base,Building *paren,int type);
	~Building();

	virtual void update();
	virtual char *getstring();

	void build_dialog();
	void build(int conn,int type);

	virtual void properties_dialog();

private:
};
class Hydro:public Building
{
public:
	Hydro(Base *base,Building *paren,int type);
	~Hydro();

	void update();
	char *getstring();

	void properties_dialog();

private:
	int crop;
	int malnutrition;
};

class Chemplant:public Building
{
public:
	int reaction;

	Chemplant(Base *base,Building *paren,int type);
	~Chemplant();

	void update();
	char *getstring();

	void properties_dialog();

private:
};


class Crewman
{
public:
	bool active; // Is crewman active (alive!)
	char name[20];
	Base *base;	

	Crewman(Base *base);
	~Crewman();

	void update();

private:
	int food,water;
};


class Base
{
public:

	double lat,lon;
	char name[50];

	Storage *store;
	
	int num_crew,max_crew;
	vector<Crewman*> crew;

	Building *root; // Root building node, points to the Ops center.

	Base(double lat,double lon);
	~Base();

	void update(int curtime);

private:
	void recurse(Building *building);
};






#endif