#include "resources.h"



const char *resname[]={"aluminium","argon","carbon","chlorine","iron","magnesium",
	"manganese","nitrogen","phosphorus","potassium","silicon","sodium","sulphur","titanium","uranium",
	"hydrogen (H2)","oxygen (O2)","methane (CH4)","water (H2O)","carbon dioxide (CO2)","carbon monoxide (CO)","hydroponic nutrients","food","organic waste"};



Storage::Storage()
{
	for(int n=0;n<ELEMENTS;n++)
	{
		res[n]=100.0;
		dres_accu[n]=0;
		dres[n]=0;
	}
	total=100*ELEMENTS;
	limit=0;
}

Storage::~Storage() { }


void Storage::day_begin()
{
	for(int n=0;n<ELEMENTS;n++)
	{
		dres[n]=dres_accu[n];
		dres_accu[n]=0;
	}
}

double Storage::add(int n,double amount) 
{
	double space=limit-total;
	if(space>amount)
	{
		res[n]+=amount;
		total+=amount;
		dres_accu[n]+=amount;
		return 0;
	}
	else
	{
		res[n]+=space;
		dres_accu[n]+=amount; // delta shows how much we would've gained, even if we didn't have space really.
		total+=space;
		return (amount-space);
	}
}
bool Storage::remove(int n,double amount)
{
	if(res[n]>=amount) 
	{
		res[n]-=amount;
		dres_accu[n]-=amount;
		return true;
	} 
	else 
	{
		dres_accu[n]-=amount;
		return false;
	}
}
double Storage::get(int n)
{
	return res[n];
}
double Storage::getdelta(int n)
{
	return dres[n];
}
bool Storage::enough(int n,double amount)
{
	if(res[n]>=amount) return true;
	else return false;
}